﻿// ActiveX Registration
// Thanks to Jonathan Abbott's post in (http://forums.microsoft.com/MSDN/ShowPost.aspx?PostID=1081416&SiteID=1)
// and his mediaplayer sidebar gadget, it was of great help when developing this self-registration code.

// Shell and file system objects
var oShell = new ActiveXObject("WScript.Shell");
var oFSO = new ActiveXObject("Scripting.FileSystemObject");
var bKeepDebugFile=true;

// Open the debugLogFile for writing (overwrites previous contents)
try{
	if (bKeepDebugFile)
		var debugLogFile = oFSO.OpenTextFile(System.Gadget.path+"\\log.txt", 2, true);
} catch(err) {bKeepDebugFile = false; debugLog("Open log.txt error " + err.name + " - " + err.message)}

//register activeX
var controlCLSID = "{02484EF0-A952-47B7-9D74-E827E5F3DC71}";
var propCLSID    = "{C16DCC44-08FB-464B-BF73-F33373EA3D0B}";
var dispCLSID    = "{16CECF38-2A83-40E8-86DB-46DA6FBA37D1}";
var eventsCLSID  = "{2B9D7DF6-157E-4259-B5F6-BFD5A33373EA}";
var typeLibCLSID = "{F93310A4-BD74-46FD-BD9B-96A28A81A2D5}";


//begin self-registration 
var ActiveXOK;
debugLog("Trying to register to HKCU.");
registerMB("HKCU");
if (!verifyActiveX()) {
    debugLog("Registration failed. Rolling back.");
    unregisterMB("HKCU");
    debugLog("Trying to register to HKLM.");
    registerMB("HKLM");
    if (!verifyActiveX()){
        debugLog("Registration failed. Rolling back.");
        unregisterMB("HKLM");
	    debugLog("ActiveX not found, error creating minibrowser ActiveX object");
    }
}
if(ActiveXOK) debugLog("ActiveX is registered correctly.");
//end self-registration    

//log debug entries
function debugLog(str) {
    str= "[" + Date() + "] " + str;
	try{
		System.Debug.outputString(str);
		if (bKeepDebugFile)
			debugLogFile.WriteLine(str);
	} catch(err) {}
}


// Verify if ActiveX control is present and registered
function verifyActiveX() {	
    var testControl;
	try{
		testControl = new ActiveXObject("MB.MBCtrl.03");
		ActiveXOK = true;
		
	} catch(err) {
        debugLog("verifyActiveX> #:" + err.number + " N:" + err.name + " M:" + err.message + " D:" + err.description);
	    testControl = null;
		ActiveXOK = false;
	}
	return ActiveXOK;
}

// Register ActiveX component
function registerMB( regRoot) {
	var classRoot = regRoot + "\\Software\\Classes\\MB.MBCtrl.03\\";
	var controlRoot = regRoot + "\\Software\\Classes\\CLSID\\" + controlCLSID + "\\";
	var propRoot = regRoot + "\\Software\\Classes\\CLSID\\" + propCLSID + "\\";
	var dispRoot = regRoot + "\\Software\\Classes\\Interface\\" + dispCLSID + "\\";
	var eventsRoot = regRoot + "\\Software\\Classes\\Interface\\" + eventsCLSID + "\\";
	var typeLibRoot = regRoot + "\\Software\\Classes\\TypeLib\\" + typeLibCLSID + "\\";

	try{
		oShell.RegWrite(classRoot,"MB Control", "REG_SZ");
		oShell.RegWrite(classRoot + "CLSID\\", controlCLSID, "REG_SZ");
		oShell.RegWrite(controlRoot, "MB Control", "REG_SZ");
		oShell.RegWrite(controlRoot + "InprocServer32\\", System.Gadget.path + "\\mb.ocx", "REG_SZ");
		oShell.RegWrite(controlRoot + "InprocServer32\\ThreadingModel", "Apartment", "REG_SZ");
		oShell.RegWrite(controlRoot + "MiscStatus\\", "0", "REG_SZ");
		oShell.RegWrite(controlRoot + "ProgID\\", "MB.MBCtrl.03", "REG_SZ");
		oShell.RegWrite(controlRoot + "TypeLib\\", typeLibCLSID, "REG_SZ");
		oShell.RegWrite(controlRoot + "Version\\", "0.3", "REG_SZ");
        //Property page. Apparently it's not necessary.
        /*
		oShell.RegWrite(propRoot, "MB Property Page", "REG_SZ");
		oShell.RegWrite(propRoot + "InprocServer32\\", System.Gadget.path + "\\mb.ocx", "REG_SZ");
		*/		
        //Events interface
        oShell.RegWrite(eventsRoot, "_DMBEvents", "REG_SZ");
		oShell.RegWrite(eventsRoot + "ProxyStubClsid\\", "{00020420-0000-0000-C000-000000000046}", "REG_SZ");
		oShell.RegWrite(eventsRoot + "ProxyStubClsid32\\", "{00020420-0000-0000-C000-000000000046}", "REG_SZ");
		oShell.RegWrite(eventsRoot + "TypeLib\\", typeLibCLSID, "REG_SZ");
		oShell.RegWrite(eventsRoot + "TypeLib\\Version", "0.3", "REG_SZ");
        //Dispatch interface
		oShell.RegWrite(dispRoot, "_DMB", "REG_SZ");
		oShell.RegWrite(dispRoot + "ProxyStubClsid\\", "{00020420-0000-0000-C000-000000000046}", "REG_SZ");
		oShell.RegWrite(dispRoot + "ProxyStubClsid32\\", "{00020420-0000-0000-C000-000000000046}", "REG_SZ");
		oShell.RegWrite(dispRoot + "TypeLib\\", typeLibCLSID, "REG_SZ");
		oShell.RegWrite(dispRoot + "TypeLib\\Version", "0.3", "REG_SZ");
        //TypeLib
		oShell.RegWrite(typeLibRoot, "", "REG_SZ");
		oShell.RegWrite(typeLibRoot + "0.3\\", "MB ActiveX Control module", "REG_SZ");
		oShell.RegWrite(typeLibRoot + "0.3\\0\\", "", "REG_SZ");
		oShell.RegWrite(typeLibRoot + "0.3\\0\\win32\\", System.Gadget.path + "\\mb.ocx", "REG_SZ");
		oShell.RegWrite(typeLibRoot + "0.3\\FLAGS\\", "2", "REG_SZ");
		oShell.RegWrite(typeLibRoot + "0.3\\HELPDIR\\", "", "REG_SZ");

	} catch(err) {debugLog("registerMB> #:" + err.number + " N:" + err.name + " M:" + err.message + " D:" + err.description);}
}



// Unregister ActiveX component
function unregisterMB(regRoot) {
	var classRoot = regRoot + "\\Software\\Classes\\MB.MBCtrl.03\\";
	var controlRoot = regRoot + "\\Software\\Classes\\CLSID\\" + controlCLSID + "\\";
	var propRoot = regRoot + "\\Software\\Classes\\CLSID\\" + propCLSID + "\\";
	var dispRoot = regRoot + "\\Software\\Classes\\Interface\\" + dispCLSID + "\\";
	var eventsRoot = regRoot + "\\Software\\Classes\\Interface\\" + eventsCLSID + "\\";
	var typeLibRoot = regRoot + "\\Software\\Classes\\TypeLib\\" + typeLibCLSID + "\\";

    //Unregister backwards
	try{		
        //TypeLib
		oShell.RegDelete(typeLibRoot + "0.3\\HELPDIR\\");
		oShell.RegDelete(typeLibRoot + "0.3\\FLAGS\\");
		oShell.RegDelete(typeLibRoot + "0.3\\0\\win32\\");
		oShell.RegDelete(typeLibRoot + "0.3\\0\\");
		oShell.RegDelete(typeLibRoot + "0.3\\");
		oShell.RegDelete(typeLibRoot);

        //Dispatch interface
		oShell.RegDelete(dispRoot + "TypeLib\\");
		oShell.RegDelete(dispRoot + "ProxyStubClsid32\\");
		oShell.RegDelete(dispRoot + "ProxyStubClsid\\");
		oShell.RegDelete(dispRoot);

        //Events interface
		oShell.RegDelete(eventsRoot + "TypeLib\\");
		oShell.RegDelete(eventsRoot + "ProxyStubClsid32\\");
		oShell.RegDelete(eventsRoot + "ProxyStubClsid\\");
        oShell.RegDelete(eventsRoot);

        //Property page. Apparently it's not necessary.
        /*
		oShell.RegDelete(propRoot + "InprocServer32\\");
		oShell.RegDelete(propRoot);
		*/		

        //Control
		oShell.RegDelete(controlRoot + "Version\\");
		oShell.RegDelete(controlRoot + "TypeLib\\");
		oShell.RegDelete(controlRoot + "ProgID\\");
		oShell.RegDelete(controlRoot + "MiscStatus\\");
		oShell.RegDelete(controlRoot + "InprocServer32\\");
		oShell.RegDelete(controlRoot);
		oShell.RegDelete(classRoot + "CLSID\\");
		oShell.RegDelete(classRoot);

	} catch(err) {debugLog("unregisterMB> #:" + err.number + " N:" + err.name + " M:" + err.message + " D:" + err.description);}
}


