﻿//MBSettings, class to hold minibrowser's settings
MBSettings = function(){
    //This is where default values are defined
    this._HomePage="http://minibrowser.info/init03.aspx";
    this._ZoomFactor=100;
    this._ScrollX=0;
    this._ScrollY=0;
    this._ScrollBarsVisible=1;

    this._RefreshFrequency=0;
    this._ShowAddressBar=true;
    this._ShowButtonBar=true;
    this._ShowStatusBar=true;
    this._ShowZoomBar=false;
    this._PageWidth=0;

}

MBSettings.prototype={
    // properties
    get_HomePage: function(){
        return this._HomePage;
    },

    
    put_HomePage: function(homePage){
        if(homePage.length>0)
            this._HomePage=homePage;
    },
    
    get_ZoomFactor: function(){
        return this._ZoomFactor;
    },
    
    put_ZoomFactor: function(zoomFactor){
        if(typeof(zoomFactor)=="number" && zoomFactor>=10 && zoomFactor<=100)
            this._ZoomFactor=zoomFactor;
    },

    get_ScrollX: function(){
        return this._ScrollX;
    },

    put_ScrollX: function(scrollX){
        if(typeof(scrollX)=="number" && scrollX>=0)
            this._ScrollX=scrollX;
    },

    get_ScrollY: function(){
        return this._ScrollY;
    },
    
    put_ScrollY: function(scrollY){
        if(typeof(scrollY)=="number" && scrollY>=0)
            this._ScrollY=scrollY;
    },

    get_ScrollBarsVisible: function(){
        return this._ScrollBarsVisible;
    },
    
    put_ScrollBarsVisible: function(scrollBarsVisible){
        if(typeof(scrollBarsVisible)=="number")
            this._ScrollBarsVisible=scrollBarsVisible;
    },

    get_RefreshFrequency: function(){
        return this._RefreshFrequency;
    },
    
    put_RefreshFrequency: function(refreshFrequency){
        if(typeof(refreshFrequency)=="number" && refreshFrequency>=0)
            this._RefreshFrequency=refreshFrequency;
    },
    
    get_ShowAddressBar: function(){
        return this._ShowAddressBar;
    },
    
    put_ShowAddressBar: function(showAddressBar){
        if(typeof(showAddressBar)=="boolean")
            this._ShowAddressBar=showAddressBar;
    },
    
    get_ShowButtonBar: function(){
        return this._ShowButtonBar;
    },
    
    put_ShowButtonBar: function(showButtonBar){
        if(typeof(showButtonBar)=="boolean")
            this._ShowButtonBar=showButtonBar;
    },
    
    get_ShowStatusBar: function(){
        return this._ShowStatusBar;
    },
    
    put_ShowStatusBar: function(showStatusBar){
        if(typeof(showStatusBar)=="boolean")
            this._ShowStatusBar=showStatusBar;
    },
    
    get_ShowZoomBar: function(){
        return this._ShowZoomBar;
    },
    
    put_ShowZoomBar: function(showZoomBar){
        if(typeof(showZoomBar)=="boolean")
            this._ShowZoomBar=showZoomBar;
    },

    get_PageWidth: function(){
        return this._PageWidth;
    },
    
    put_PageWidth: function(pageWidth){
        if(typeof(pageWidth)=="number" && pageWidth>=0)
            this._PageWidth=pageWidth;
    },
    
    // methods
    
    //read settings from disk
    ReadGadgetSettings: function(){
        this.put_HomePage(System.Gadget.Settings.readString("HomePage"));
        this.put_ZoomFactor(System.Gadget.Settings.read("ZoomFactor"));
        this.put_ScrollX(System.Gadget.Settings.read("ScrollX"));
        this.put_ScrollY(System.Gadget.Settings.read("ScrollY"));
        this.put_ScrollBarsVisible(System.Gadget.Settings.read("ScrollBarsVisible"));    
    },
    
    //read from disk the settings that are changed in the settings window
    ReadDialogSettings: function(){
        this.put_RefreshFrequency(System.Gadget.Settings.read("RefreshFrequency"));
        this.put_ShowAddressBar(System.Gadget.Settings.read("ShowAddressBar"));
        this.put_ShowButtonBar(System.Gadget.Settings.read("ShowButtonBar"));
        this.put_ShowZoomBar(System.Gadget.Settings.read("ShowZoomBar"));
        this.put_ShowStatusBar(System.Gadget.Settings.read("ShowStatusBar"));
        this.put_PageWidth(System.Gadget.Settings.read("PageWidth"));
    },
    
    //write settings to disk
    WriteGadgetSettings: function(){
        System.Gadget.Settings.writeString("HomePage", this.get_HomePage());
        System.Gadget.Settings.write("ZoomFactor", this.get_ZoomFactor());
        System.Gadget.Settings.write("ScrollX", this.get_ScrollX());
        System.Gadget.Settings.write("ScrollY", this.get_ScrollY());
        System.Gadget.Settings.write("ScrollBarsVisible", this.get_ScrollBarsVisible());
    },

    //write the settings that are changed in the settings window
    WriteDialogSettings: function(){
        System.Gadget.Settings.write("RefreshFrequency", this.get_RefreshFrequency());
        System.Gadget.Settings.write("ShowAddressBar", this.get_ShowAddressBar());
        System.Gadget.Settings.write("ShowButtonBar", this.get_ShowButtonBar());
        System.Gadget.Settings.write("ShowStatusBar", this.get_ShowStatusBar());
        System.Gadget.Settings.write("ShowZoomBar", this.get_ShowZoomBar());
        System.Gadget.Settings.write("PageWidth", this.get_PageWidth());
    },

    //read temporary settings (used to pass values between gadget page and settings page)
    ReadDialogSettingsFromTemp: function(){
        this.put_RefreshFrequency(System.Gadget.Settings.read("temp_RefreshFrequency"));
        this.put_ShowAddressBar(System.Gadget.Settings.read("temp_AddressBarVisible"));
        this.put_ShowButtonBar(System.Gadget.Settings.read("temp_ButtonBarVisible"));
        this.put_ShowZoomBar(System.Gadget.Settings.read("temp_ZoomBarVisible"));
        this.put_ShowStatusBar(System.Gadget.Settings.read("temp_StatusBarVisible"));
        this.put_PageWidth(System.Gadget.Settings.read("temp_PageWidth"));
    }

}

